/*
    Copyright (C) 2005 Ahmed Rezine and Noomene Ben Henda

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information: Ahmed Rezine <Rezine.Ahemd@it.uu.se> and Noomene Ben Henda <Noomene.BenHenda@it.uu.se>
*/

/**@file action.h
 *ADT for actions.
 *
 *@author Ahmed Rezine and Noomene Ben-Henda
 */
#ifndef ACTION_H
#define ACTION_H

#include "task.h"
#include "tlist.h"
#include "process.h"
#include "exconst.h"

using namespace action;
using namespace process;

class Action:public TList<Task>
{
 public:
  typedef TList<Task>::iterator iterator;
  typedef TList<Task>::const_iterator const_iterator;
 
 public:
  Action() {}
  GExConst operator()(const PWord* w, const PWord::const_iterator pos, const Global_Symbol* gc) const
  {
    const_iterator iter=begin(),iter_end=end();
    GExConst result(*w,*gc);
    GExConst temp_res;
    result.word.adjust(w->begin(),pos,w->end());
    for(; iter != iter_end; ++iter)
      {
	temp_res=(**iter)(&result.word.word,result.word.curr,&result.gs);
	result=temp_res;
      }
    return result;
  }

};

#endif

