/*
    Copyright (C) 2005 Ahmed Rezine and Noomene Ben Henda

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information: Ahmed Rezine <Rezine.Ahemd@it.uu.se> and Noomene Ben Henda <Noomene.BenHenda@it.uu.se>
*/

/**@file definition.h
 *File for managing global variables and access to them.
 *
 *@author Ahmed Rezine and Noomene Ben-Henda
 */

#ifndef DEFINTION_H
#define DEFINTION_H

#include "process.h"

extern process::Variable_Table Process_Definition;
extern process::Variable_Table Global_Definition;

/**
 *function template definition
 */
template<class T>
const process::Variable_Table* get_definition(const T& x)
{
  return &Process_Definition;
}

/**
 *function template first specialization: for processes.
 */
/*template<>
const process::Variable_Table* get_definition<>(const process::Process& x)
{
  return &Process_Definition;
}
*/
/**
 *function template second specialization: for global symbols.
 */
 /*template<>
const process::Variable_Table* get_definition<>(const process::Global_Symbol& x)
{
  return &Global_Definition;
}
 */

#endif

