/*
    Copyright (C) 2005 Ahmed Rezine and Noomene Ben Henda

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information: Ahmed Rezine <Rezine.Ahemd@it.uu.se> and Noomene Ben Henda <Noomene.BenHenda@it.uu.se>
*/

/**@file guard.h
 *ADT for guards.
 *
 *@author Ahmed Rezine and Noomene Ben-Henda
 */

#ifndef GUARD_H
#define GUARD_H

#include "condition.h"
#include "tlist.h"
#include "process.h"

using namespace guard;
using namespace process;

/**
 *A guard is a conjunction of conditions.
 */
class Guard:public TList<Condition>
{
 public:
  typedef TList<Condition>::iterator iterator;
  typedef TList<Condition>::const_iterator const_iterator;

 public:
  Guard() {}
  /**input should be a valid range*/
  bool operator()(const PWord* w, const PWord::const_iterator pos, const Global_Symbol* gc) const
  {
    const_iterator iter=begin(),iter_end=end();
    for(; iter != iter_end; iter++)
      {
	if (!(**iter)(w,pos,gc)) {return false;}
      }
    return true;
  }


};

#endif

