#include "options_handler.h"
#include "process.h"
#include "configuration.h"
#include "predicate.h"
#include "variable.h"
#include "starpredicate.h"
#include "starquantifier.h"
#include "creator.h"
#include "condition.h"
#include "guard.h"
#include "transform.h"
#include "rtransform.h"
#include "my_functional.h"
#include "task.h"
#include "action.h"
#include "transition.h"
#include "starpre.h"
#include "algorithms.h"

#include <string>
#include <iostream>
#include <unistd.h>
#include <map>
#include <fstream>
#include <sys/times.h>

using namespace std;
using namespace process;
using namespace predicate;
using namespace variable;
using namespace starpredicate;
using namespace starquantifier;
using namespace guard;
using namespace my_stl;
using namespace transform;
using namespace rtransform;
using namespace action;
using namespace creator;

process::Variable_Table Process_Definition;
process::Variable_Table Global_Definition;

Transitions* trans;
Configuration* conf_init;
Configuration* conf_final;
UCSetConf* Init;
UCSetConf* Final;

int line_no = 0;
extern int yyparse();
extern FILE *yyin;


int bur(std::string input_name)
{
  if((yyin=fopen(input_name.c_str(),"r")))
    {
      /**Parsing the input*/
      std::cout << "Parsing " << input_name << "... " ;
      yyparse();
      std::cout << " Parsing Done." << std::endl;
      /*       
    cout << "Pvar elements: " << endl;
    for(Variable_Table::iterator vtit=Process_Definition.begin(); vtit != Process_Definition.end(); ++vtit)
      cout << vtit->first << " : " << vtit->second.first.first << " - " << vtit->second.first.second << endl;

    cout << "Gvar elements: " << endl;
    for(Variable_Table::iterator vtit=Global_Definition.begin(); vtit != Global_Definition.end(); ++vtit)
      cout << vtit->first << " : " << vtit->second.first.first << " - " << vtit->second.first.second << endl;
      
    cout << "initial configuration: " << *conf_init << endl;
    cout << "final configuration: " << *conf_final << endl;

    const PWord* pword= dynamic_cast<const PWord*> ((conf_final->processes).getPtr());

    assert(trans);
    
    Global_Symbol GF(&Global_Definition);*/

      /*    std::vector<const Transition*>::iterator it_trans=trans->begin();
    for(; it_trans!=trans->end(); it_trans++)
      {
	cout << "**************************************" << endl;
	Transition tr(*(*(it_trans)));
	cout << "transition: " << tr << endl;
	cout << "working word: " << endl << *pword << endl; 
	cout << "pointing at: " << *(((pword->begin()))) << endl;
	
	cout << "firing forward: " << endl;
	Transition::forward_iterator fo=tr.fire_forward(pword, ((pword->begin())), 
							&GF); //    (dynamic_cast<const Global_Symbol*> (conf->global_condition.getPtr()))
	for(;!fo.end();++fo)
	  {
	    cout << (*fo).word.word << endl;
	  }
	
	
	
	cout << "firing backward: " << endl;
	
	Transition::backward_iterator ba=tr.fire_backward(pword,((pword->begin())),
							  &GF); //(dynamic_cast<const Global_Symbol*> (conf->global_condition.getPtr())));
	
	for(;!ba.end();++ba)
	  {
	    cout << (*ba).word.word << endl;
	  }
      }
      */

      //cout << "initial " << *Init << endl;

      /*      std::vector<const Transition*>::iterator it_trans=trans->begin();
    for(; it_trans!=trans->end(); it_trans++)
      {
	cout << "**************************************" << endl;
	Transition tr(*(*(it_trans)));
	cout << "transition: " << tr << endl;
      }
      */

      struct tms start_time;
      struct tms end_time;




      StarPre spre(trans);
      SBR sbr(Init,Final,&spre);


      //      std::vector<const Transition*>::iterator it_trans=trans->begin();
      //for(;it_trans!=trans->end(); it_trans++)
      //	{
      //	  delete(*it_trans);
      //	}


      times(&start_time);
      std::cout << sbr.run() << std::endl;
      times(&end_time);

      delete(trans);

      clock_t total_time_ticks = end_time.tms_utime - start_time.tms_utime;
      unsigned int total_time_msecs = total_time_ticks * 1000 / sysconf(_SC_CLK_TCK);
      
      cout << "Total time (ms):" << total_time_msecs << endl;    


    }
  else {std::cout << "Can not open : " << input_name << std::endl;}

  return 0;
}

int bck(std::string l)
{
  return 0;
}

int frw(std::string number_steps)
{
  return 0;
}

int main(unsigned int argc, char* argv[])
{
  
  ArgumentHandler program(1);
  
  /* add_option takes the follow arguments:
     long option name, short option name, address of function to call,
     option description, can only be called once {1|0}, takes an argument {1|0}
     if an argument is not present, the arg passed will be "NULL"
     if an argument is present and this is specified with add_option,
     the argument will be passed to the function to be called */
  
  program.add_option("--bur","-p",&bur,"Backward Upward Reachability",0,1);
  program.set_program_information("This program is still under developpent");
  program.set_usage_information(argv[0]);
  program.parse(argc, argv);

  /* option for calling the backward reachability algorithm, this option 
     doesn't take any argument, however an input file, where the system is
     defined, is needed */
  program.add_option("--bck","-b",&bck,"Backward Upward Reachability",0,1);

  /* option for calling the forward simulation  algorithm, this option 
     takes the number of steps as argument, however an input file, where 
     the system is defined, is needed */
  program.add_option("--frw","-f",&frw,"Forward Simulation",0,1);

  return 0;

}
