%{
#include "process.h"
#include "configuration.h"
#include "predicate.h"
#include "variable.h"
#include "starpredicate.h"
#include "starquantifier.h"
#include "creator.h"
#include "condition.h"
#include "guard.h"
#include "transform.h"
#include "rtransform.h"
#include "my_functional.h"
#include "task.h"
#include "action.h"
#include "transition.h"
#include "starpre.h"

#include <iostream>

using namespace std;
using namespace process;
using namespace predicate;
using namespace variable;
using namespace starpredicate;
using namespace starquantifier;
using namespace guard;
using namespace my_stl;
using namespace transform;
using namespace rtransform;
using namespace action;
using namespace creator;

#include "pred_parser.tab.hh"

extern int line_no;
%}

%option noyywrap

ID   [A-Za-z_?][A-Za-z_?0-9]*
INT  [+-]?[0-9]+

%%

{INT}           { yylval.n = atoi(yytext);  return INT;}
";"             { return TOKEN_SEMCOLON;}
":"		{return TOKEN_COLON;}
","		{ return TOKEN_COMMA;}
"*"		{ return TOKEN_STAR;}
"local"		{ return TOKEN_LOCAL;}
"global"	{ return TOKEN_GLOBAL;}
"transitions"	{ return TOKEN_TRANSITION;}
"initial"	{ return TOKEN_INITIAL;}
"final"		{ return TOKEN_FINAL;}
"bool"		{ return TOKEN_BOOL; }
"true"		{ return TOKEN_TRUE; }
"false"		{ return TOKEN_FALSE; }

"|"		{ return TOKEN_OR; }
"&"		{ return TOKEN_AND; }
"!="		{ return TOKEN_DIFFERENT; }
"=>"		{ return TOKEN_IMPLY;}
">="		{ return TOKEN_GEQUAL; }
"<="		{ return TOKEN_LEQUAL; }
":="		{ return TOKEN_ASSIGN;}
"<"		{ return TOKEN_LESS; }
">"		{ return TOKEN_GREAT; }
"="		{ return TOKEN_EQUAL; }
"foralla"	{ return TOKEN_FORALLA;}
"foralll"	{ return TOKEN_FORALLL;}
"forallr"	{ return TOKEN_FORALLR;}
"itexistsa"	{ return TOKEN_ITEXISTSA;}
"itexistsl"	{ return TOKEN_ITEXISTSL;}
"itexistsr"	{ return TOKEN_ITEXISTSR;}
"new"		{ return TOKEN_NEW;}
"["		{ return TOKEN_LEFTBR; }
"]"		{ return TOKEN_RIGHTBR; }
".."		{ return TOKEN_DOTDOT; }
"("		{ return TOKEN_LEFTP; }
")"		{ return TOKEN_RIGHTP; }

[ \t\v\f\r\b]+  { /* skip */ }

[\n]            { ++line_no; }

{ID}            { yylval.str = new std::string(yytext); /*std::cout << *(yylval.str) << std::endl;*/ return ID;}
.               { std::cerr<<"Parse error for "<<yytext<<" at line "<<line_no<<std::endl; }
"#"[ A-Za-z_?0-9.,:=><#+()&]*  { /* skip */ }
%%



