/*
    Copyright (C) 2005 Ahmed Rezine and Noomene Ben Henda

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information: Ahmed Rezine <Rezine.Ahmedd@it.uu.se> and Noomene Ben Henda <Noomene.BenHenda@it.uu.se>
*/

/**@file symbol.h
 *ADT for symbols.
 *
 *@author Ahmed Rezine and Noomene Ben-Henda
 */

#ifndef SYMBOL_H
#define SYMBOL_H
#include "printable.h"
#include "ref.h"

/**
 *This class implements symbols. We notice that the equality test operator is needed to
 *be able to handle the order on words.
 */
class Symbol:public Printable
{
 public:
  virtual bool equal(const Symbol& S) const=0;
  virtual ~Symbol() {};
};

typedef Ref<const Symbol> SymRef;

inline bool operator==(const Symbol& S1 , const Symbol& S2)
{ return S1.equal(S2); }

inline bool operator==(const SymRef S1 , const SymRef S2)
{ return S1->equal(*S2); }

#endif

