#include "stringword.h"
#include "intword.h"
#include "tword_op.h"

#include <iostream>

using namespace std;

bool test_stringword()
{
  String w1,w2,w3,w4;

  w1.push_back('a'); w1.push_back('b'); w1.push_back('c');
  w2.push_back('d'); w2.push_back('e'); w2.push_back('f');
  w3.push_back('d'); w3.push_back('e'); w3.push_back('f');w3.push_back('g');
  w4.push_back('a');

  UCSetString ucs;

  ucs.insert(StringRef(new String(w1)));
  ucs.insert(StringRef(new String(w2)));

  cout << "UCS=" << ucs << endl;

  SetString sc;

  sc.insert(StringRef(new String(w1)));

  return ucs.includes(StringRef(new String(w3))) && (!(ucs.includes(StringRef(new String(w4))))) && sc.includes(StringRef(new String(w1)));
}

bool test_stringgen()
{
  String w1;
  w1.push_back('a'); w1.push_back('b'); w1.push_back('c');
  
  TGenerator<char> gen;
  TGenerator<char>::IWR i=gen.start('d',w1.begin(),w1.end());
  int counter=0;
  for(;!i.end();++i){++counter; std::cout << *i << std::endl; }

  return counter==4;
}

bool test_intword()
{
  Int w1,w2,w3,w4;

  w1.push_back(1); w1.push_back(2); w1.push_back(3);
  w2.push_back(4); w2.push_back(5); w2.push_back(6);
  w3.push_back(4); w3.push_back(5); w3.push_back(6);w3.push_back(7);
  w4.push_back(1);

  UCSetInt ucs;
  

  ucs.insert(IntRef(new Int(w1)));
  ucs.insert(IntRef(new Int(w2)));

  SetInt sc;

  sc.insert(IntRef(new Int(w1)));

  cout << "UCS=" << ucs << endl;

  return ucs.includes(IntRef(new Int(w3))) && (!(ucs.includes(IntRef(new Int(w4))))) && sc.includes(IntRef(new Int(w1)));
}

int main()
{
	struct
  {
    string name;
    bool (*test_f)(void);
  }

  tests[] =
    {
      {"StringWords", test_stringword},
      {"IntWords",test_intword},
      {"StringGeneration", test_stringgen}
    };

  unsigned int i;
  string result;

  for (i = 0; i < sizeof(tests)/sizeof(tests[0]); i++) {
    cout <<tests[i].name << "... ";
    result = tests[i].test_f() == true ? "Ok" : "Fail";
    cout << result << endl;
  }

  return 0;
}
