/*
    Copyright (C) 2005 Ahmed Rezine and Noomene Ben Henda

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information: Ahmed Rezine <Rezine.Ahmed@it.uu.se> and Noomene Ben Henda <Noomene.BenHenda@it.uu.se>
*/

/**@file word.h
 *ADT for words.
 *
 *@author Ahmed Rezine and Noomene Ben-Henda
 */

#ifndef WORD_H
#define WORD_H

#include "printable.h"
#include "symbol.h"
#include "ref.h"

/**
 *This class implements words.
 */

class Word:public Printable
{
 public:

  /**
   * common word operations.
   */
  virtual bool less(const Word& W) const=0;
  virtual ~Word() {};
};

typedef Ref<const Word> WordRef;

/**order on words*/
inline bool operator<=(const Word& W1 , const Word& W2)
{ return W1.less(W2); }

inline bool operator<=(const WordRef W1 , const WordRef W2)
{ return W1->less(*W2); }

#endif

